#!/usr/bin/env perl
#
# J.P.Boggis 19/01/2004:  Simple embedded Perl functions to decode escaped
# 			  characters in text and base64 decode messages
# 			  for matching against ACL's.
# 			  	     
# 	     04/05/2004:  Added function to decode HTML entities.

# Replace escaped characters in text with true ASCII equivalent
sub unescape_string {
    my $Decoded = $_[0];
    $Decoded =~ s/[=%]([a-fA-F0-9]{2,2})/chr(hex($1))/eg;
    return $Decoded;
}

# Decode HTML entities
sub decode_html_entities {
    use HTML::Entities;

    my $Decoded = $_[0];
    $Decoded =~ s/=[\r\n ]//eg;
    $Decoded =~ s/[\r]//eg;
    $Decoded = decode_entities($Decoded);
    return $Decoded;
}

# Decode Base64 encoded text
sub base64_decode_string {
    use MIME::Base64;

    my $Decoded = $_[0];
    $Decoded = decode_base64($Decoded);
    return $Decoded;
}
